package com.s3ai.controllers.cinemas;

import com.s3ai.entities.Cinema;
import com.s3ai.services.CinemaService;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.UUID;

public class CinemaEdit extends HttpServlet {

    CinemaService cinemaService = CinemaService.getInstance();

    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String id = req.getParameter("id");
        Cinema cinema = null;
        String name = req.getParameter("name") == null ? "" : req.getParameter("name");
        Integer seatsCount = Integer.parseInt(req.getParameter("seatsCount") == null ? "" : req.getParameter("seatsCount"));
        String location = req.getParameter("location") == null ? "" : req.getParameter("location");
        if (null == id) {
            cinema = new Cinema();
            cinema.setId(UUID.randomUUID());
            cinemaService.fillCinemaFields(cinema, name, location, seatsCount);
            cinemaService.saveCinema(cinema);
        } else {
            cinema = cinemaService.getCinemaById(UUID.fromString(id));
            cinemaService.fillCinemaFields(cinema, name, location, seatsCount);
            cinemaService.updateCinema(cinema);
        }
        resp.sendRedirect("/cinemas");
    }

    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        HttpSession session = req.getSession();
        String idToEdit = req.getParameter("id");
        Cinema cinema = null;
        RequestDispatcher dispatcher = req.getRequestDispatcher("/pages/cinemas/edit.jsp");
        if (idToEdit != null) {
            cinema = cinemaService.getCinemaById(UUID.fromString(idToEdit));
        } else {
            cinema = new Cinema();
        }
        session.setAttribute("cinema", cinema);
        dispatcher.forward(req, resp);
    }

    protected void doDelete(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String id = req.getParameter("id");
        if (null == id) {
            resp.sendError(420, "Object cannot be found");
            return;
        }
        var cinema = cinemaService.getCinemaById(UUID.fromString(id));
        if (null == cinema) {
            resp.sendError(420, "Object cannot be found");
            return;
        }
        cinemaService.deleteCinema(cinema);
        resp.setStatus(200);
    }
}