package com.s3ai.controllers.cinemas;

import com.s3ai.entities.Cinema;
import com.s3ai.services.CinemaService;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;

public class CinemaFill extends HttpServlet {
    CinemaService cinemaService = CinemaService.getInstance();

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        List<String> locations = cinemaService.getAllCinemas().stream().map(Cinema::getLocation).distinct().collect(Collectors.toList());
        System.out.println(locations);
        var writer = response.getWriter();
        writer.println("FILLED Instances:");
        var random = new Random();
        for (int i = 0; i < 300; i++) {
            var cinema = new Cinema();
            cinemaService.fillCinemaFields(cinema, "Test" + (i + 7), locations.get(random.nextInt(locations.size())), Math.abs(random.nextInt()));
            cinemaService.saveCinema(cinema);
            writer.println(cinema);
        }
    }
}
