package com.s3ai.services;

import com.s3ai.dao.DAO;
import com.s3ai.entities.Cinema;

import java.util.List;
import java.util.UUID;

public class CinemaService {
    private static CinemaService cinemaService;
    private DAO dao;

    private CinemaService() {
        this.dao = DAO.getInstance();
    }

    public static CinemaService getInstance() {
        if (cinemaService == null) {
            cinemaService = new CinemaService();
        }
        return cinemaService;
    }

    public List<Cinema> getAllCinemas() {
        return dao.getAllCinemas();
    }

    public Cinema getCinemaById(UUID id) {
        return dao.getCinemaById(id);
    }

    public void saveCinema(Cinema cinema) {
        dao.saveEntity(cinema);
    }

    public void updateCinema(Cinema cinema) {
        dao.updateEntity(cinema);
    }

    public void deleteCinema(Cinema cinema) {
        dao.deleteEntity(cinema);
    }

    public void fillCinemaFields(Cinema cinema, String name, String location, Integer seatsCount) {
        cinema.setName(name);
        cinema.setLocation(location);
        cinema.setSeatsCount(seatsCount);
    }
}
